package util;
import java.util.Vector;

import util.Command;
public class HistoryUndoer implements util.Undoer
{
    Vector historyList = new Vector();
    int nextCommandIndex = 0;

    public void execute (Command c)
    {
		//System.out.println("next command index " + nextCommandIndex);
        c.execute();
        historyList.insertElementAt(c, nextCommandIndex);
        nextCommandIndex++;
    }

    public boolean undo()
    {
        if (nextCommandIndex == 0)
            return (false);
        else
        {
            nextCommandIndex--;
            Command c = (Command) historyList.elementAt(nextCommandIndex);
            if (!c.isUndoable())
                return (false);
            else {
                c.undo();
                return (true);
            }
        }
    }

    public boolean redo()
    {
        if (nextCommandIndex == historyList.size())
            return (false);
        else
        {
            Command c = (Command) historyList.elementAt(nextCommandIndex);
            nextCommandIndex++;
            if (!c.isUndoable())
                return (false);
            else {
                c.execute();
                return (true);
            }
        }
    }

    private void writeObject(java.io.ObjectOutputStream out)
        throws java.io.IOException
    {
        out.defaultWriteObject();
    }

    private void readObject(java.io.ObjectInputStream in)
        throws java.io.IOException, ClassNotFoundException
    {
        in.defaultReadObject();
    }


}