package util.awt;
import java.awt.AWTEvent;
import java.awt.Graphics;
import java.util.ArrayList;
import java.util.List;
import java.util.Vector;
public class ADelegateFrame extends java.awt.Frame implements DelegateFrame  {	
	public ADelegateFrame() {
		super();
		ComponentRegistry.register(this);
	}
	Vector<Painter> painters = new Vector();
	public void addPainter(Painter painter) {
		if (painters.contains(painter))
			return;
		painters.add(painter);			
	}
	public void removePainter(Painter painter) {
		if (painters.contains(painter))
			return;
		painters.remove(painter);		
		
	}
    public void paint(Graphics g) {
    	super.paint(g);
    	for (int i = 0; i < painters.size(); i++)
    		painters.elementAt(i).paint(this, g);     	
    } 
    protected void processEvent(AWTEvent event) {
		//do not do anything by default. 
    	//let the method below be called for notifying.
	}
    public void processEvent(ASerializableAWTEvent event) {    	    		
    	if (!event.isLocal()) {
    		if (event.isResizeEvent()) {
    			this.setSize(event.getSize()); 
    			return;
    		}
    	}    	     		
    	super.processEvent(event.getAWTEvent());
	}   
}
