package util.models;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;
import java.util.List;
import java.util.Vector;

//import bus.uigen.DynamicEnum;
@util.annotations.StructurePattern(util.annotations.StructurePatternNames.ENUM_PATTERN)
public class ADynamicEnum<ElementType> implements java.io.Serializable, DynamicEnum<ElementType>   {
	List<ElementType> choices = new Vector();
	ElementType currentChoice;
	public static final String UNINIT_ENUM = " ";
	public ADynamicEnum() {		
		//initCurrentChoice();
	}
	public ADynamicEnum(List<ElementType> theInitialChoices) {
		//init();	
		choices = theInitialChoices;
		initCurrentChoice();
	}
	public ADynamicEnum(ElementType[] theInitialChoices) {
		//init();
		for (int i = 0; i < theInitialChoices.length; i++)
		choices.add(theInitialChoices[i]);
		initCurrentChoice();
	}
	public ADynamicEnum(ElementType theInitialChoice) {
		//choices.add(theInitialChoice);
		//choices.add(theInitialChoice);
		setValue (theInitialChoice);
	}
	void initCurrentChoice() {
		
		if (choices.size() > 0) {
			ElementType choice = choices.get(0);
			currentChoice = choice;
			//setValue (choices.get(0));
		}
	}
	/* (non-Javadoc)
	 * @see bus.uigen.DynamicEnum#choicesSize()
	 */
	public int choicesSize() {
		return choices.size();
	}
	/* (non-Javadoc)
	 * @see bus.uigen.DynamicEnum#choiceAt(int)
	 */
	public ElementType choiceAt(int i) {
		return (ElementType) choices.get(i);
	}
	/* (non-Javadoc)
	 * @see bus.uigen.DynamicEnum#getValue()
	 */
	public ElementType getValue() {
		return currentChoice;
	}
	/* (non-Javadoc)
	 * @see bus.uigen.DynamicEnum#getChoices()
	 */
	/*
	public List<ElementType> getChoices() {
		return choices;
	}
	*/
	public List<ElementType>  getChoices() {
		return choices;
	}
	/* (non-Javadoc)
	 * @see bus.uigen.DynamicEnum#setValue(ElementType)
	 */
	void maybeAddChoice (ElementType newVal) {
		if (!choices.contains(newVal)) {
			choices.add(newVal);
			propertyChange.firePropertyChange("choices", null,
	                choices);
		}		
		
	}
	public void setValue(ElementType newVal) {
		Object oldChoice =  currentChoice;
		currentChoice = newVal;
		maybeAddChoice(newVal);
//		if (!choices.contains(newVal)) {
//			choices.add(newVal);
//			propertyChange.firePropertyChange("choices", null,
//	                choices);
//		}
		propertyChange.firePropertyChange("value", oldChoice,
                newVal);
	}
	public String toString() {
		if (currentChoice == null)
			//return "Uninitialized dynamic enumeration";
			return UNINIT_ENUM;
		return currentChoice.toString();
	}
	//override it to add a choice that is not of ElementType
	public void addUserChoice(String newValue) {
		
	}
	public void replaceChoice (int index, ElementType newName) {
		if (index >= choices.size() -1)
			return;
		choices.set(index, newName);
	}
	public boolean equals(ADynamicEnum otherObject) {
		return otherObject.getValue().equals(getValue()) &
		otherObject.choices.equals(choices); 
		//otherObject.getValue().equals(getValue());
	}
	transient PropertyChangeSupport propertyChange = new PropertyChangeSupport(this) ;
	@util.annotations.ObserverRegisterer(util.annotations.ObserverTypes.PROPERTY_LISTENER)
	public void addPropertyChangeListener(PropertyChangeListener l) {        	
        propertyChange.addPropertyChangeListener(l);
    }
	
	

}