package util.models;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Vector;
import java.util.Enumeration;

//import bus.uigen.VectorChangeSupport;
//import bus.uigen.VectorListenable;
//import bus.uigen.VectorListener;
//import bus.uigen.VectorMethodsListener;
@util.annotations.StructurePattern(util.annotations.StructurePatternNames.VECTOR_PATTERN)
//public class AListenableString extends AMutableString implements VectorListenable  {
public class AListenableString extends AMutableString implements ListenableString  {
	public AListenableString (String s) {
		super(s);
		initSerializedObject();
	}
	public AListenableString () {
		super();
		initSerializedObject();
	}
	public void addElement(char c) {
		super.addElement(c);
		stringChangeSupport.elementAdded(new Character(c));
	}
	@Override
	public boolean addAll(Collection<? extends Character> elements) {
		boolean retVal = super.addAll(elements);
		// TODO Auto-generated method stub
		stringChangeSupport.elementsAdded(elements);
		return retVal;
	}
	
	public void addElement(String s) {
		super.addElement(s);
		List<Character> elementsAdded = new ArrayList();
		for (int i = 0; i < s.length(); i++) {
			elementsAdded.add(s.charAt(i));
		}
		stringChangeSupport.elementsAdded(elementsAdded);
	}
	public void insertElementAt(char element, int pos) {
		super.insertElementAt(element, pos);
		stringChangeSupport.elementInserted(new Character(element), pos);
	}
	
	public void removeElementAt(int pos, int cnt) {
		super.removeElementAt(pos, cnt);
		stringChangeSupport.elementRemoved(pos);
		
	}
	@Override
	public void clear() {
		super.clear();
		stringChangeSupport.elementsCleared();
	}
	@Override
	public void initSerializedObject() {
		try {
		stringChangeSupport = new VectorChangeSupport(this.toString());;
		} catch (Exception e) {
			e.printStackTrace();
		}
		//setParentLinksOfDescendents();
	}
	//StringChangeSupport stringChangeSupport = new StringChangeSupport(this);
	//transient VectorChangeSupport<Character> stringChangeSupport = new VectorChangeSupport(this.toString());
	transient VectorChangeSupport<Character> stringChangeSupport;
	@util.annotations.ObserverRegisterer(util.annotations.ObserverTypes.VECTOR_LISTENER)
	public void addVectorListener(VectorListener vectorListener) {
		stringChangeSupport.addVectorListener(vectorListener);
	}
	public void removeVectorListener(VectorListener vectorListener) {
		stringChangeSupport.removeVectorListener(vectorListener);
	}
	public void addVectorMethodsListener(VectorMethodsListener vectorListener) {
		stringChangeSupport.addVectorMethodsListener(vectorListener);
	}
	public void removeVectorMethodsListener(VectorMethodsListener vectorListener) {
		stringChangeSupport.removeVectorMethodsListener(vectorListener);
	}
}
