package util.models;

import java.util.List;

import util.annotations.ComponentWidth;
import util.annotations.Visible;
// reprsents a String and a dynamic enum, each choice in which is a checked
// object. The checked object is itself a set name and a boolean, which indicates
// if the string is in the set or not.
public class AStringInSets implements StringInSets  {
	String string;
	CheckedStringEnum checkedStringEnum;
	public AStringInSets(String theString, CheckedStringEnum theCheckedStringEnum) {
		string = theString;
		checkedStringEnum = theCheckedStringEnum;
	}
	
	public String getString() {
		return string;
	}
	public String getCheckedSets() {
		List<String> stringSets = checkedStringEnum.getCheckedStrings();
		String retVal = "";
		for (int i = 0; i < stringSets.size(); i++) {
			if (i > 0) 
				retVal += ", ";
			retVal += stringSets.get(i);
		}
		return  retVal;
	}
	
	public String getNumLists() {
		int numLists = checkedStringEnum.getCheckedStrings().size();
		if (numLists == 1)
			return numLists + " list";
		else
			return numLists + " lists";		
	}
	
	public CheckedStringEnum getSets() {
		return checkedStringEnum;
	}
	
	
	
}

