package util.models;
import java.util.Vector;
public class BoundedBuffer <ElementType> {
	Vector<ElementType> buffer = new Vector();
	final int MAXSIZE = 100;
	public synchronized void put(ElementType element) {
		try {
			//System.out.println("put of " + element + " by" + Thread.currentThread());
			while (buffer.size() >= MAXSIZE)
				this.wait();			
			//if (buffer.size() == 0) {
				//System.out.println("Notify called by" + Thread.currentThread());
				this.notify();
			//}
			buffer.addElement(element);
		} catch (Exception e) {};
	}
	public synchronized void put(ElementType element, long timeOut) {
		try {
			//System.out.println("put called by" + Thread.currentThread());
			while (buffer.size() >= MAXSIZE)
				this.wait(timeOut);			
			//if (buffer.size() == 0) {
				//System.out.println("Notify called by" + Thread.currentThread());
				this.notify();
			//}
			buffer.addElement(element);
		} catch (Exception e) {};
	}
	public synchronized ElementType get() {
		try {
			while (buffer.size() == 0) {
				//System.out.println("wait called by" + Thread.currentThread());
				this.wait();
			}
			//System.out.println("method invocation thread:" + Thread.currentThread());
			ElementType retVal = buffer.elementAt(0);
			if (buffer.size() >= MAXSIZE)				
				this.notify();
			buffer.removeElementAt(0);
			//System.out.println("get returning " + retVal + " to" + Thread.currentThread());
			return retVal;
		} catch (Exception e) {
			return null;
		}
	}
	public synchronized ElementType get(long timeOut) {
		try {
			boolean waited = false;
			while (buffer.size() == 0) {
				if (waited)
					return null;
				//System.out.println("wait called by" + Thread.currentThread());
				waited = true;
				this.wait(timeOut);
			}
			//System.out.println("method invocation thread:" + Thread.currentThread());
			ElementType retVal = buffer.elementAt(0);
			if (buffer.size() >= MAXSIZE)				
				this.notify();
			buffer.removeElementAt(0);
			//System.out.println("get returning " + retVal + " to" + Thread.currentThread());
			return retVal;
		} catch (Exception e) {
			return null;
		}
	}

}