package util.multicast;

import java.rmi.RemoteException;
import java.util.ArrayList;
import java.util.List;

public class ASessionListenable {
	List<SessionListener> listeners = new ArrayList();
	public void addSessionListener(SessionListener theListener) {
		if (listeners.contains(theListener))
			return;
		listeners.add(theListener);
	}
	public void removeSessionListener(SessionListener theListener) {
		listeners.remove(theListener);
	}	
	void notifyClientJoined (String theClientName, MessageReceiver theClient, String theApplicationName) throws RemoteException {
		for (SessionListener listener:listeners) {			
			listener.userJoined(theClientName, theClient, theApplicationName);			
		}
	}
	void notifyClentLeft (String theClientName, MessageReceiver theClient, String theApplicationName) throws RemoteException {
		for (SessionListener listener:listeners) {			
			listener.userLeft(theClientName, theClient, theApplicationName);			
		}
	}


}
